app/models/Voiceprompt.php
<?php

namespace app\models;

use Yii;

/**
 * This is the model class for table "voiceprompt".
 *
 * @property int $id
 * @property int $id_account
 * @property string $name
 * @property string $source
 * @property string $msg
 * @property string $lang
 * @property string $speed
 *
 * @property Account $account
 */
class Voiceprompt extends \yii\db\ActiveRecord
{

    const SRC_UPLOAD = 'upload';
    const SRC_TTS = 'tts';
    const SRC_RECORD = 'record';

    const SC_UPLOAD = 'upload';
    const SC_TTS = 'tts';
    const SC_RECORD = 'record';


    public $file;
    public $keep;

    /**
     * {@inheritdoc}
     */
    public static function tableName()
    {
        return 'ivr.ivredit_voiceprompt';
    }

    /**
     * {@inheritdoc}
     */
    public function rules()
    {
        return [
            [['name',], 'required'],
            [['file'], 'required', 'on' => [self::SC_UPLOAD]],
            [['lang'], 'required', 'on' => [self::SC_TTS]],
            [['msg'], 'string'],
            [['speed'], 'number', 'on' => [self::SC_TTS]],
            [['name'], 'string', 'max' => 255],
            [['lang'], 'string', 'max' => 2, 'on' => [self::SC_TTS]],
            [['file'], 'file', 'on' => [self::SC_UPLOAD]]
        ];
    }

    /**
     * {@inheritdoc}
     */
    public function attributeLabels()
    {
        return [
            'name' => Yii::t('app', 'Name'),
            'source' => Yii::t('app', 'Source'),
            'msg' => Yii::t('app', 'Message'),
            'lang' => Yii::t('app', 'Language'),
            'speed' => Yii::t('app', 'Speed'),
            'file' => Yii::t('app', 'File')
        ];
    }


    public function languages() {
        return array(
            'en' => 'English',
            'cs' => 'Czech'
        );
    }

    private function hasName() {
        return isset($this->name) || $this->name != '';
    }

    public function validate($attributeNames = NULL, $clearErrors = true) {
        if(!$this->hasName()) {
            $this->name = pathinfo($this->file->name, PATHINFO_FILENAME);
        }
        return parent::validate($attributeNames, $clearErrors);
    }
}

app/controllers/VoicepromptController.php
<?php

namespace app\controllers;

use Yii;
use app\models\Voiceprompt;
use app\components\VoicePromptFile;
use yii\data\ActiveDataProvider;
use yii\web\Controller;
use yii\web\UploadedFile;
use yii\web\NotFoundHttpException;
use yii\filters\VerbFilter;
use yii\filters\AccessControl;
use yii\data\Sort;

/**
 * VoicepromptController implements the CRUD actions for Voiceprompt model.
 */
class VoicepromptController extends Controller
{
    /**
     * {@inheritdoc}
     */
    public function behaviors()
    {
        return [
            'access' => [
                'class' => AccessControl::className(),
                'rules' => [
                    [
                        'allow' => true,
                        'roles' => ['@'],
                    ],
                ],
            ],
            'verbs' => [
                'class' => VerbFilter::className(),
                'actions' => [
                    'delete' => ['POST'],
                ],
            ],
        ];
    }

    /**
     * Lists all Voiceprompt models.
     * @return mixed
     */
    public function actionIndex()
    {
        $dataProvider = new ActiveDataProvider([
            'query' => Voiceprompt::find(),
            'sort' => new Sort(['attributes' => ['name']]),
        ]);

        return $this->render('index', [
            'dataProvider' => $dataProvider,
        ]);
    }

    public function actionCreatevoiceprompt() {	
        $model = new Voiceprompt();
        $model->scenario = Voiceprompt::SC_UPLOAD;

        $ajax = Yii::$app->request->isAjax;
        if ($ajax) {
            Yii::$app->response->format = \yii\web\Response::FORMAT_JSON;
        }

        if ($model->load(Yii::$app->request->post())) {
            $model->file = UploadedFile::getInstance($model, 'file');
            if ($model->validate()) {
                $model->source = Voiceprompt::SRC_UPLOAD;
                $transaction = Yii::$app->db->beginTransaction();
                $vpf = new VoicePromptFile(VoicePromptFile::TYPE_VP, $model->name);
                if ($vpf->exists()) {
                    $model->addError('name', Yii::t('app', 'Name already exists'));
                } else {
                    if ($model->save()) {
                        $extension = pathinfo($model->file->name, PATHINFO_EXTENSION);
                        $filename = $model->file->tempName . "." . $extension;
                        move_uploaded_file($model->file->tempName, $filename);
                        if (($ret = $vpf->save($filename)) == VoicePromptFile::ERR_OK) {
                            $transaction->commit();
                            if ($ajax) {
                                return true;
                            } else {
                                return $this->redirect(['index']);
                            }
                        } else {
                            $model->addError('file', VoicePromptFile::errMsg($ret));
                        }
                    }
                } 
                $transaction->rollback();
            }
        } else {
            if ($ajax)
                return "Invalid request data";
        }
        if ($ajax) {
            $err = '';
            $errors = $model->getFirstErrors();
            foreach ($errors as $e) {
                $err = $e;
                break;
            }
             
            if ($err == '') {
                $err = "Unknown error";
            }
            return $err;
        } else { 
            return $this->render('create', ['model' => $model]);
        }
    }

    public function actionChangefile($id) {
        $model = Voiceprompt::findOne($id);
        $model->scenario = Voiceprompt::SC_UPLOAD;

        if ($model->load(Yii::$app->request->post())) {
            $model->file = UploadedFile::getInstance($model, 'file');
            if ($model->validate()) {
                $transaction = Yii::$app->db->beginTransaction();
                if ($model->save()) {
                    $uploadedFile = new VoicePromptFile(VoicePromptFile::TYPE_VP, $model->name);
                    $extension = pathinfo($model->file->tempName, PATHINFO_EXTENSION);
                    $filename = $model->file->tempName . "." . $extension;
                    move_uploaded_file($model->file->tempName, $filename);
                    if (($ret = $uploadedFile->save($filename)) == VoicePromptFile::ERR_OK) {
                        $transaction->commit();
                        return $this->redirect(['index']);
                    } else {
                        $model->addError('file', VoicePromptFile::errMsg($ret));
                    }
                }
                $transaction->rollback();
            }
        }
        return $this->render('upload', ['model' => $model]);
    }

    public function actionCreatetts() {
        $model = new Voiceprompt;
        $model->scenario = Voiceprompt::SC_TTS;

        if ($model->load(Yii::$app->request->post())) {
            $model->source = Voiceprompt::SRC_TTS;
                    
            if ($model->validate()) {
                $vp = new VoicePromptFile(VoicePromptFile::TYPE_VP, $model->name);
                        
                if ($vp->exists()) {
                    $model->addError('name', Yii::t('app', 'Name already exists'));
                } else { 
                    $trans = Yii::$app->db->beginTransaction();
                    $model->save();
                    if ($vp->mkFromText($model->msg, $model->lang, $model->speed)) {
                        $trans->commit();
                        return $this->redirect(['index']);
                    } else {
                        $model->addError('name', Yii::t('app', 'TTS failed'));
                    }
                    $trans->rollback();
                }
                    
            }
        }
        return $this->render('tts', ['model' => $model]);
    }
		

    public function actionUpdate($id) {
        $model = Voiceprompt::findOne($id);
        $oldname = $model->name;
        
        if ($model->load(Yii::$app->request->post())) {	
            // msg, lang, speed is unsafe on update scenario
            // to protect source of tts  VP
            if ($model->source != "tts") {
                $model->msg = $_POST['Voiceprompt']['msg'];
                // $model->lang = $_POST['Voiceprompt']['lang'];
                $model->speed = 1.0;
            }
            
            $trans = Yii::$app->db->beginTransaction();
            if ($model->save()) {
                $ok = 1;
                if ($model->name != $oldname) {
                    $vpf = new VoicePromptFile(VoicePromptFile::TYPE_VP, $oldname);
                    if (!$vpf->rename($model->name)) {
                        $model->addError('name', Yii::t("app", "File rename failed"));
                        $ok = 0;
                    }
                }
                    
                if ($ok) {
                    $trans->commit();
                    return $this->redirect(['index']);
                }
            }	
            $trans->rollback();
        }
    
	return $this->render('update', ['model' => $model]);		
    }

    public function actionUpdatetts($id) {
        $model = $this->findModel($id);
        $oldname = $model->name;
        
        if ($model->load(Yii::$app->request->post())) {
            $oldname = $model->name;
		
            $model->scenario = Voiceprompt::SC_TTS;
            $model->source = Voiceprompt::SRC_TTS;
		
            $trans = Yii::$app->db->beginTransaction();
            if ($model->save()) {
                $vpf = new VoicePromptFile(VoicePromptFile::TYPE_VP, $model->name);
                if ($vpf->mkFromText($model->msg, $model->lang, $model->speed)) {
                    if ($model->name != $oldname) {
                        $vpold = new VoicePromptFile(VoicePromptFile::TYPE_VP, $model->name, $oldname);
                        $vpold->delete();
                    }
			
                    $trans->commit();
                    return $this->redirect(['index']);
                }
            }
				
				
            $trans->rollback();
        }
        return $this->render('tts', array('model' => $model));
    }


    public function actionDelete($id) {
        $vp = $this->findModel($id);
        
        $trans = Yii::$app->db->beginTransaction();
        if ($vp->delete()) {	
            $vpf = new VoicePromptFile(VoicePromptFile::TYPE_VP, $vp->name);
            if ($vpf->delete()) {
                $trans->commit();
            } else { 
                $trans->rollback();
            }
        }

        // if AJAX request (triggered by deletion via admin grid view), we should not redirect the browser
        if(!isset($_GET['ajax'])) {
            $this->redirect(['index']);
	}
    }


    public function actionMassupload() {
        $data = Yii::$app->request->post();

        if ($data) {
            print_r($data);
            exit;
        }

        return $this->render('massupload');
    }

    public function actionPlay($id) {
        $vp = Voiceprompt::findOne($id);
        if (!$vp)
            return;

        $rec = new VoicePromptFile(VoicePromptFile::TYPE_VP, $vp->name);
		
        if (!$rec->exists()) {
            return;
        }
        
        $sound_file = $rec->getPath();

        header('Content-type: audio/wav');
        header('Cache-Control: must-revalidate, post-check=0, pre-check=0');
        header("Content-Length: " . filesize($sound_file));

        @ob_clean();
        flush();
        readfile($sound_file);
    }	


    /**
     * Finds the Voiceprompt model based on its primary key value.
     * If the model is not found, a 404 HTTP exception will be thrown.
     * @param integer $id
     * @return Voiceprompt the loaded model
     * @throws NotFoundHttpException if the model cannot be found
     */
    protected function findModel($id)
    {

app/views/voiceprompt/_create_form.php
<?php
use yii\helpers\Html;
?>

<div class="form">

<?php $form = yii\widgets\ActiveForm::begin([
	'id'=>'voiceprompt-create-form',
	'options' => ['enctype' => 'multipart/form-data'],
	'enableAjaxValidation'=>false,
	'action' => ['createvoiceprompt'] 
]); ?>

	<p class="note"><?= Yii::t('app', 'Fields with {star} are required', ['star' => '<span class="required">*</span>']) ?></p>

	<?php echo $form->errorSummary($model); ?>

	<div class="row">
		<?= $form->field($model, 'name')->textInput(['size'=>60,'maxlength'=>255]); ?>
	</div>

	<div class="row">
		<?= $form->field($model, 'msg')->textarea(['width'=>255,'height'=>10]); ?>
	</div>
	
	<div class="row">
		<?= $form->field($model, 'file')->fileInput(); ?>
	</div>

	<div class="row buttons">
		<?= Html::submitButton('Upload', ['class' => 'btn btn-primary itb-submit']); ?>
	</div>
                        	
	

<?php $form->end(); ?>

</div><!-- form -->

app/views/voiceprompt/_massupload_form.php
<?php
use yii\helpers\Html;
use yii\helpers\Url;
use yii\grid\GridView;
use yii\data\ArrayDataProvider;

app\assets\MassuploadAsset::register($this);
?>

<div class="form">

<div id='errors' style="color: red; font-weight: bold">
<ul></ul>
</div>


<?= GridView::widget([
	'id'=>'voiceprompt-massupload-grid',
	'dataProvider' => new ArrayDataProvider(['allModels' => []]),
        'layout' => "{items}",
        'emptyText' => Yii::t('app', 'No files selected'),
	'columns'=> [
		[ 
			'header' => Yii::t('app', 'File name'),
			'headerOptions' => [ 'style' => 'width: 40%' ]
		],
		[ 
			'header' => Yii::t('app', 'Voice prompt name'),
			'headerOptions' => [ 'style' => 'width: 40%' ]
		],
		[
			'header' => Yii::t('app', 'Delete'),
			'headerOptions' => [ 'style' => 'width: 10%' ]
		],
		[ 
			'header' => Yii::t('app', 'Result'),
			'headerOptions' => [ 'style' => 'width: 10%' ]
		],
	],
]);
?>

<?php $form = yii\widgets\ActiveForm::begin([
	'id'=>'voiceprompt-massupload-form',
	'options' => ['enctype' => 'multipart/form-data'],
	'enableAjaxValidation'=>false,
	'action' => ['massupload'] 
]); ?>

	<div class="row buttons">
		<?= Html::button(Yii::t('app', 'Select files'), ['id' => 'button-select']); ?>
	</div>

	<div class="row" style="margin: 25px 0 10px 0;">
		<?= Html::fileInput('dummy', null, [
			'style' => 'display: none',
			'multiple' => true,
			'accept' => 'audio/*',
			'id' => 'fileinput'
		]); ?>
	</div>

	<div class="row buttons">
		<?= Html::button(Yii::t('app', 'Upload'), ['id' => 'button-upload', 'class' => 'btn btn-primary itb-submit']); ?>
	</div>
                        	
<?php $form->end(); ?>


<script>
submitUrl="<?= Url::to(['createvoiceprompt']) ?>";
indexUrl="<?= Url::to(['index']) ?>";
</script>

</div><!-- form -->

app/views/voiceprompt/_tts_form.php
<?php

use yii\helpers\Html;

?>

<div class="form">

<?php $form = yii\widgets\ActiveForm::begin([
	'id'=>'voiceprompt-tts-form',
	'enableAjaxValidation'=>false,
	'action' => $model->isNewRecord ? ['createtts'] : ['updatetts']
]); ?>


	<p class="note"><?= Yii::t('app', 'Fields with {star} are required', ['star' => '<span class="required">*</span>']) ?></p>

	<?= $form->errorSummary($model); ?>

	<div class="row">
		<?= $form->field($model, 'name')->textInput(['size'=>60,'maxlength'=>255]); ?>
	</div>
	
	<div class="row">
		<?= $form->field($model, 'msg')->textarea(); ?>
	</div>
	
	<div class="row">
		<?= $form->field($model, 'lang')->listBox(app\models\Voiceprompt::languages(), ['size' => 1, 'prompt' => '- Select language -']); ?>
	</div>
	
	<div class="row">
		<?= $form->field($model, 'speed')->textInput(['size'=>5,'maxlength'=>5]); ?>
	</div>
	

	<div class="row buttons">
		<?= Html::submitButton($model->isNewRecord ? Yii:t('app', 'Create') : Yii::t('app', 'Update'); ?>
	</div>

<?php $form->end(); ?>

</div><!-- form -->

app/views/voiceprompt/_update_form.php
<?php

use yii\helpers\Html;

?>

<div class="form">

<?php $form = yii\widgets\ActiveForm::begin([
	'id'=>'voiceprompt-update-form',
	'enableAjaxValidation'=>false,
	'action' => ['update', 'id' => $model->id]
]); ?>

	<p class="note"><?= Yii::t('app', 'Fields with {star} are required', ['star' => '<span class="required">*</span>']) ?></p>

	<?= $form->errorSummary($model); ?>

	<div class="row">
		<?= $form->field($model, 'name')->textInput(['size'=>60,'maxlength'=>255]); ?>
	</div>
<!--
	<div class="row">
		<?= $form->field($model, 'source')->label() ?>
		<?= $model->source ?>
	</div>
-->

<?php if ($model->source != 'tts') { ?>
	<div class="row">
		<?= $form->field($model, 'msg')->textArea(); ?>
	</div>
<?php }  ?>

	<div class="row buttons">
		<?= Html::submitButton(Yii::t('app', 'Update'), ['class' => 'btm btn-ptimary itb-submit']); ?>
	</div>

<?php $form->end(); ?>

</div><!-- form -->

app/views/voiceprompt/_upload_form.php
<?php
use yii\helpers\Html;
?>

<div class="form">

<?php $form = yii\widgets\ActiveForm::begin([
	'id'=>'voiceprompt-upload-form',
	'options' => ['enctype' => 'multipart/form-data'],
	'enableAjaxValidation'=>false,
	'action' => ['changefile', 'id' => $model->id] 
]); ?>
	
	<div class="row" style="margin: 25px 0 10px 0;">
		<?= $form->field($model, 'file')->fileInput(); ?>
	</div>

	<div class="row buttons">
		<?= Html::submitButton('Upload', ['class' => 'btm btn-ptimary itb-submit']); ?>
	</div>
                        	
	

<?php $form->end(); ?>

</div><!-- form -->

app/views/voiceprompt/create.php
<h1><?= Yii::t('app', 'Upload Voice prompt') ?></h1>

<?= $this->render('_create_form', ['model' => $model]); ?>

app/views/voiceprompt/index.php
<?php


use yii\helpers\Html;
use yii\helpers\Url;
use yii\grid\GridView;

app\assets\PlayfileAsset::register($this);
app\assets\FaAsset::register($this);

?>

<p style="display: inline-block">
<?= Html::a(Yii::t('app', 'Load'), ['createvoiceprompt'], ['class' => 'btn btn-primary itb-submit']) ?></p>
<?= Html::a(Yii::t('app', 'Mass upload'), ['massupload'], ['class' => 'btn btn-primary itb-submit']) ?></p>
<!--
<?= Html::a(Yii::t('app', 'Create using TTS'), ['createtts'], ['class' => 'btn btn-success']) ?></p>
<?= Html::a(Yii::t('app', 'Create from recording'), ['/recorded/indexc'], ['class' => 'btn btn-success']) ?>
-->
</p>

<?= GridView::widget([
	'id'=>'voiceprompt-grid',
	'dataProvider'=> $dataProvider,
        'layout' => "{items}\n{pager}",
	'columns'=> [
		'name',
		'msg',
/*
		'lang',
		'source',
*/
		[
			'class'=>'yii\\grid\\ActionColumn',
			'template' => "{update} {play} {changefile} {delete}",
			'buttons' => [
				'play' => function($url, $model, $key) {
					return Html::a('<i class="fa fa-play" onclick="onclickPlay(event)"></i>', $url , [
					'title' => Yii::t('app', 'Play'),
				    ]);
				},
				'changefile' => function($url, $model, $key) {
					return Html::a('<i class="fa fa-upload"></i>', $url , [
					'title' => Yii::t('app', 'Change file'),
					]);
				},
/* 
				'updatetts' => function($url, $model, $key) {
					return Html::a('<i class="fa fa-file-text-o"></i>', $url);
				}
*/				
			],

			'urlCreator' => function($action, $model, $key, $index, $col) {
				if ($action == 'play')
					return Url::to(['/voiceprompt/play', 'id' => $key, 'time' => time()]);
				else
					return Url::to(['/voiceprompt/' . $action, 'id' => $key]);
			},
			'options' => ['width'=>'80'],
		],
	],
]); 
?>

app/views/voiceprompt/massupload.php
<h1><?= Yii::t('app', 'Voice prompt mass upload') ?></h1>

<?= $this->render('_massupload_form'); ?>

app/views/voiceprompt/tts.php
<h1><?= Yii::t('app', 'Create Voice prompt via TTS') ?></h1>

<?= $this->render('_tts_form', ["model" => $model]); ?>

app/views/voiceprompt/update.php
<h1><?= Yii::t('app', 'Update Voice prompt') ?></h1>

<?= $this->render('_update_form', ["model" => $model]); ?>

app/views/voiceprompt/upload.php
<h1><?= Yii::t('app', 'Upload Voice prompt') ?></h1>

<?= $this->render('_upload_form', ["model" => $model]); ?>